dropzone {
  display: block;
  width: 100%;
  height: auto;

  &[fxflex] {
    display: flex;
    flex-direction: inherit;
    min-width: 0;
    min-height: 0;

    -webkit-box-direction: inherit;
    -webkit-box-orient: inherit;

    & > .dropzone {
      &.dz-wrapper {
        flex: 1 1 auto;
        min-width: 0;
        min-height: 0;

        -webkit-box-flex: 1;
      }
    }
  }

  &[fxlayout] {
    align-items: inherit;
    align-content: inherit;
    justify-content: inherit;

    -webkit-box-align: inherit;
    -webkit-box-pack: inherit;

    & > .dropzone {
      &.dz-wrapper {
        &.dz-single {
          display: flex;
          flex-direction: column;
          align-items: center;
          align-content: center;
          justify-content: center;

          -webkit-box-align: center;
          -webkit-box-direction: column;
          -webkit-box-orient: column;
          -webkit-box-pack: center;
        }

        &.dz-multiple {
          display: flex;
          flex-flow: row wrap;
          align-items: start;
          align-content: start;
          justify-content: space-between;

          -webkit-box-align: start;
          -webkit-box-direction: row;
          -webkit-box-orient: row;
          -webkit-box-pack: start;
        }
      }
    }
  }

  & > .dropzone {
    &.dz-wrapper {
      position: relative;

      overflow: auto;
      width: 100%;
      min-height: 0;
      max-height: 100%;
      padding: 0;
      border: none;

      color: #666;
      background: transparent;

      .dz-message {
        position: relative;

        display: inline-block;
        overflow: auto;
        width: calc(100% - 16px);
        min-width: calc(100% - 16px);
        min-height: 40px;
        max-width: calc(100% - 16px);
        max-height: 100%;
        margin: 8px;
        border: 2px dashed #aaa;

        background-color: #eee;

        .dz-text {
          position: absolute;
          top: 50%;

          width: 100%;
          padding: 8px 24px;

          text-align: center;

          transform: translateY(-50%);
        }

        .dz-image {
          width: 100%;
          height: 100%;

          background-size: contain;
          background-repeat: no-repeat;
          background-position: 50% 50%;
        }

        &.disabled {
          cursor: not-allowed;

          .dz-text {
            opacity: 0.5;
          }
        }

        &.dz-placeholder {
          border-color: rgba(#aaa, 0);

          .dz-text {
            position: absolute;
            z-index: 1;
            top: 0;
            right: 10%;
            left: 10%;

            opacity: 0;

            font-weight: bold;
            background-color: rgba(#fff, 0.5);

            transform: translateY(-50%);
            transition:
              filter 250ms ease-in-out,
              opacity 250ms ease-in-out,
              border-color 250ms ease-in-out;
          }

          &:hover:not(.disabled) {
            border-color: #aaa;

            .dz-text {
              opacity: 1;
            }

            .dz-image {
              -webkit-filter: blur(8px);

              filter: blur(8px);
            }
          }
        }
      }

      .dz-preview {
        margin: 8px;

        .dz-details {
          padding: 24px;
        }

        .dz-progress {
          width: 80%;
          margin-left: -40%;
          border: 1px solid #aaa;
          border-radius: 4px;

          .dz-upload {
            background-color: #666;
          }
        }

        .dz-filename {
          span {
            display: block;
            overflow: hidden;
            width: 100%;
            max-width: 100%;

            text-overflow: ellipsis;

            &:hover {
              overflow: visible;

              white-space: normal;
              word-wrap: break-word;
            }
          }
        }
      }

      &.dz-single {
        &.dz-started {
          .dz-message {
            display: none;
          }
        }

        .dz-message {
          width: 100%;
          height: 100%;
        }

        .dz-preview {
          width: calc(100% - 16px);
          height: 100%;

          .dz-image {
            width: 100%;
            height: 100%;
            border-radius: 0;

            img {
              display: block;
              width: 100%;
              height: auto;
              margin: 0;
            }
          }
        }

        .dz-error-message {
          top: 50%;
          left: 50%;

          transform: translateX(-50%) translateY(100%);
        }
      }

      &.dz-multiple {
        &.dz-started {
          .dz-message {
            display: inline-block;
          }
        }
      }
    }
  }
}
